% ===== carrier_wave_combfilter.m ========   ======
% Author: A. Prodeus
Fs = 22050;                                      %  
T = 2; N = T*Fs;                               %   2 
x = zeros(N,1);
y1 = zeros(N,1);
y = zeros(N,1);

% unit impulse signal of length N
%x(1)=1; 

%  
x = randn(N,1);
t = 0:1/Fs:1/Fs*(N-1);                      %   

%   
g=0.75;                                               % 
ddf = 400;                            %    
ttau = 1/ddf; M = round(ttau*Fs);     % 
Delayline=zeros(M,1);                    % memory allocation for length M
c = 1-g;                                 %  
for n=1:length(x);
y1(n)=c*x(n)+g*Delayline(M);
Delayline=[y1(n);Delayline(1:M-1)];
end;

%       
df = 4000;                                         %   
tau = 1/df;                                         %  
beta = 1/(tau*Fs);                             %   
y(1)=y1(1);
for k = 2:length(y1)
    y(k) = (1-beta)*y(k-1)+beta*y1(k);
end
y1 = y; y(1)=y1(1);
for k = 2:length(y1)
    y(k) = (1-beta)*y(k-1)+beta*y1(k);
end
 
figure; plot(t,y);                   %   
xlabel(', '); ylabel(''); 
title('');

% 
[H,f] = freqz(y,1,10000,Fs);
figure; plot(f,20*log10(abs(H)));
xlabel(', '); ylabel(', '); 
title('');

%    
y = y/max(abs(y))*0.99;
