% ===  ogib.m ===
%     
Fs = 22050;                        %  
beta = 9.07e-4;                    %   ( = 50 )
% beta = 2*beta;                     %   ( = 25 )

%   
T = 2;                             %    
N = T*Fs;                          %    
t = 0:1/Fs:1/Fs*(N-1);             %   
D = 0.25:0.5:T; D = D';            %    
w = 0.12;                          %     
z1 = pulstran(t,D,@rectpuls,w);

%   
z(1)=z1(1);
for k = 2:length(z1)
    z(k) = (1-beta)*z(k-1)+beta*z1(k);
end

%  
figure;
subplot(211),plot(t,z1);axis([0 2 -0.2 1.2])
xlabel(', '); ylabel(''); title('- . -')
subplot(212),plot(t,z)
xlabel(', '); ylabel(''); title('')
set(gcf,'Color',[1 1 1]);

z = z';